Default_UpdateInterval = 0.01;
Align_UpdateInterval = 0.01;

local nameWordDeath, rankWordDeath, IconWordDeath, cost, isFunnel, powerType, castTime, minRange, maxRange  = GetSpellInfo("Shadow Word: Death");
local IconWordDeath2 = "Interface\\ICONS\\Spell_Shadow_DemonicFortitude.blp";
local highlight = "Interface\\PaperDollInfoFrame\\UI-GearManager-ItemButton-Highlight.blp";
local isVisible=false;
local pulsen=0;
local pulse=1;
local pulsefreq=0.05;
function SetVisibility()
local name = GetSpecialization();
if (name == 3) then
	SWD:EnableMouse(true);
	SWDTexture:Show()
	SWDTEXT:Show()
	if(not isVisible) then
		SWD:SetScript("OnUpdate", SWD_OnUpdate);
	end
	isVisible=true;
else
	SWD:EnableMouse(false);
	SWDTexture:Hide()
	SWDTEXT:Hide()
	SWDHighlight:Hide()
	isVisible=false;
	SWD:SetScript("OnUpdate", nil);
end
end
TimeSinceSWD = 0;
defaultText="";
function SWD_OnLoad()
	SWD:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	SWD:RegisterEvent("VARIABLES_LOADED");
	SWD:RegisterEvent("ADDON_LOADED");
	SWD:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
	--SWD:RegisterEvent("GLYPH_ADDED");
	--SWD:RegisterEvent("GLYPH_REMOVED");
	--SWD:RegisterEvent("GLYPH_UPDATED");
	--SWD:RegisterEvent("GLYPH_ENABLED");
	--SWD:RegisterEvent("GLYPH_DISABLED");
	SWD:RegisterEvent("PLAYER_LOGIN");
	SWD:RegisterEvent("LEARNED_SPELL_IN_TAB");
	SWD:RegisterEvent("PLAYER_TARGET_CHANGED");
	SWD:RegisterEvent("UNIT_TARGET");
	SWD:EnableMouseWheel(true)
SWD:SetScript("OnMouseWheel", function(self, delta)
	mouseWheel(delta)
end)
	SWD:SetScript("OnUpdate", SWD_OnUpdate);
	SWDTexture:SetTexture(IconWordDeath2)
	SWDTexture:Show()
	SWDHighlight:SetTexture(highlight)
	SWDHighlight:Hide()
	SWDTEXT:SetText(defaultText)
	SWDTEXT:Show()
	didReset = false;
	didCast = false;
	SWD:SetClampedToScreen( true )
	SWD:RegisterForDrag("LeftButton");
	CheckPlayerCooldown()
	SWDTexture:SetVertexColor(1, 1, 1);
	SetVisibility();
end
function mouseWheel(delta)
	if(not isLocked) then
		if swdscale >= 2 then
		if(delta > 0) then
			swdscale=swdscale+0.07
		else
			swdscale=swdscale-0.07
		end
		else
		if(delta > 0) then
			swdscale=swdscale+0.04
		else
			swdscale=swdscale-0.04
		end
		end
		if swdscale < 0.3 then
			swdscale = 0.3
		elseif swdscale > 4 then
			swdscale=4
		end
		SWD:SetScale(swdscale);
	end
end
function relativeFrameOffset(point, x, y)
local s = string.sub(point, 0, 3);
local e = string.sub(point, string.len(point)-3, 3);
if point == "CENTER" then 
x=x+256;
y=y+256;
else
if s == "TOP" then 
y=y+512;
elseif s == "BOT" then 
y=y+0;
else
y=y+256;
end
if e == "GHT" then 
x=x+512;
elseif e == "EFT" then 
x=x+0;
else
x=x+256;
end
end
return x,y;
end
function saveVariable()
	point, relativeTo, relativePoint, xOfs, yOfs = SWD:GetPoint()
	--xOfs,yOfs=relativeFrameOffset(relativePoint, xOfs, yOfs);
	--SWD:ClearAllPoints();
	--SWD:SetPoint("BOTTOMLEFT", 0, "BOTTOMLEFT", xOfs, yOfs);
	--point, relativeTo, relativePoint, xOfs, yOfs = SWD:GetPoint()
	--print(point, relativeTo, relativePoint, xOfs, yOfs);
	swdr=point;
	swdx=xOfs;
	swdy=yOfs;
end
function SWD_SetDText(locked)
	isLocked=locked;
	if (locked) then
		defaultText="";
		SWDTEXT:SetText(defaultText);
	else
		defaultText="|cffffffffMove|r";
		SWDTEXT:SetText(defaultText);
	end
end
count=0
time1=0
TimeSinceLastUpdate=0;
isLocked=true;
onCooldown=false
didCast = false;
didReset = false;
function SWD_OnUpdate(self,elapsed)
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed;
	while (TimeSinceLastUpdate > Align_UpdateInterval) do
		if(didCast or didReset or onCooldown)then
			CheckPlayerCooldown();
		end
		local mhealth = UnitHealthMax("target");
		local health = UnitHealth("target");
		local percentage = health/mhealth;
		if(UnitCanAttack("player","target") and percentage~=0 and percentage <= 0.20) then
			SWDHighlight:Show()
			pulse = pulse + pulsefreq;
			if(pulse > 1) then
				pulse=0;
				if(pulsen == 0) then
					SWDHighlight:SetVertexColor(1, 1, 1);
				else
					SWDHighlight:SetVertexColor(.2, .2, .2);
				end
				pulsen=((pulsen+1) % 2);
			end
		else
			pulse=1;
			pulsen=0;
			SWDHighlight:Hide()
			SWDTexture:SetVertexColor(.3, .3, .3);
		end
		skip = TimeSinceLastUpdate/Align_UpdateInterval;
		if(skip >= 3) then
			TimeSinceLastUpdate=TimeSinceLastUpdate-((skip-3)*Align_UpdateInterval);
		end
		TimeSinceLastUpdate = TimeSinceLastUpdate-Align_UpdateInterval;
	end
end
lastCast=-1
i2=0
function SWD_OnEvent(self, event, ...)
	if(event == "VARIABLES_LOADED") then
		if (swdscale == nil) then
		swdscale=1.5
		end
		SWD:ClearAllPoints();
		SWD:SetUserPlaced(true);
		SWD:SetScale(swdscale);
		if(swdx ~= nil and swdy ~= nil and swdr ~= nil) then
		SWD:SetPoint(swdr, nil, swdr, swdx, swdy);
		else
		SWD:SetPoint("TOPLEFT", nil, "TOPLEFT", 100, 100);
		end
		point, relativeTo, relativePoint, xOfs, yOfs = SWD:GetPoint()
		print(point, relativeTo, relativePoint, xOfs, yOfs);
		print(event, ...);
	print(swdx, swdy, swdr, swdscale);
	elseif(event == "ACTIVE_TALENT_GROUP_CHANGED") then
		SetVisibility();
	elseif(not isVisible) then
		return;
	elseif(event == "UNIT_TARGET") then
		if (UnitCanAttack("player","target") == nil) then
			SWDHighlight:Hide()
			CheckPlayerCooldown()
		end
	elseif(event == "UNIT_SPELLCAST_SUCCEEDED") then
		local arg1, arg2, arg3, arg4, arg5 = ...;
		if(arg1=="player" and arg5 == 32379 and lastCast ~= arg4) then
			if(didReset)then                                                                
				didReset = false;
			end
			TimeSinceSWD=GetTime()-0.02;
			didCast = true;
			lastCast=arg4
		end
	--elseif(strfind(event,"^GLYPH_")~=nil)then
	--	CheckPlayerCooldown()
	elseif(event == "PLAYER_LOGIN") then
		SWD_OnLoad()
	elseif(event == "ADDON_LOADED" and ...== "SWD") then
		SWD_OnLoad()
	end
end
	
lastCooldwn = 0
stayGreen = 0
cooldownTime = 8
li=0
hasSWD=true
function HasSWD()
	start, duration, enabled = GetSpellCooldown("Shadow Word: Death")
	if(start == nil or duration == nil or enabled== nil) then
	hasSWD=false
	else
	hasSWD=true
	SWDTexture:Show()
	end
end
function CheckPlayerCooldown()
	local enabled = false
	local start = 0
	local duration = 0
	start, duration, enabled = GetSpellCooldown("Shadow Word: Death")
	if start then
		SWDTexture:Show()
		if start ~= 0 and not didReset then
			onCooldown=true
			local timeV = GetTime();
			local coolDwn2 = (timeV-start);
			local coolDwn = duration-(timeV-start);
			if didCast then
				if(duration > 6) then
					didReset = false;
					SWDTexture:SetVertexColor(0.15, 0.15, 0.15);
				else
					didReset = true;
					SWDTexture:SetVertexColor(0.6, 0.1, 0.1);
				end
			end
			SWDTEXT:SetText(round(coolDwn,1));
		else
			onCooldown=false
			if(didCast) then
				didCast = false;
				didReset = true;
			end  
			if (didReset) then 
				local tim = GetTime()
				local coolDwn=6-(tim-TimeSinceSWD);
				if(coolDwn>0)then
					SWDTEXT:SetText(round(coolDwn,1));
					SWDTexture:SetVertexColor(0.6, 0.1, 0.1);
				elseif(coolDwn<=-2)then
					SWDTexture:SetVertexColor(1, 1, 1);
					SWDTEXT:SetText(defaultText);
				else
					SWDTexture:SetVertexColor(0.1, 0.6, 0.1);
					SWDTEXT:SetText(defaultText);
				end
			else
				SWDTexture:SetVertexColor(1, 1, 1);
				SWDTEXT:SetText(defaultText)
				lastCooldwn=0;
				didReset=false
			end
		end
	else
		SWDTexture:Hide()
		SWDTEXT:SetText(defaultText)
	end
return 
end
function round(num, idp)
  local mult = 10^(idp or 0)
  local rnd = floor(num * mult + 0.5) / mult
  if(mod(rnd, 1) == 0) then
	rnd=rnd..".0"
  end
  return rnd
end